##
## Makefile for Makefile in /home/InfoCraft/
##
## Made by Julien Roulleau
## Login   <InfoCraft@epitech.net>
##
## Started on  Fri Oct 14 11:33:42 2016 Julien Roulleau
## Last update Thu Mar 16 23:38:11 2017 Roulleau Julien
##

SRC	=	main.c				\
		raytracer.c			\
		window.c			\
		render.c			\
		parser.c			\
		src/calc_dir_vector.c		\
		src/cone.c			\
		src/cylinder.c			\
		src/light.c			\
		src/my_put_pixel.c		\
		src/plane.c			\
		src/rotate.c			\
		src/sphere.c			\
		src/translate.c			\
		src/utils.c			\
		src/sf.c			\
		lib/src/is/is.c			\
		lib/src/nbr/my_getnbr.c		\
		lib/src/nbr/my_nbrlen.c		\
		lib/src/nbr/my_putnbr.c		\
		lib/src/str/get_next_line.c	\
		lib/src/str/merge_str.c		\
		lib/src/str/my_strcmp.c		\
		lib/src/str/my_putstr.c		\
		lib/src/str/my_strdup.c		\
		lib/src/str/my_strlen.c		\
		lib/src/str/str_to_wordtab.c

SRCD	=	$(filter-out main.c, $(SRC))
SRCD	+=	main_debug.c

OBJ	=	$(SRC:.c=.o)
OBJD	=	$(SRCD:.c=.o)

NAME	=	raytracer1
NAMED	=	$(NAME)_debug

CC	= 	gcc

CFLAGS	=	-W -Wall -Werror -Wextra
CFLAGS	+=	-I./inc/

LIB	=	-lm
LIB	+=	-lcsfml-graphics -lcsfml-window -lcsfml-system -lcsfml-audio
LIB	+=	-lsfml-graphics -lsfml-window -lsfml-system -lsfml-audio

COMP	=	$(CC) $(CFLAGS) -o $@ $^ $(LIB)

BUILD	=	ar rc $(NAME) $(OBJ)

PARAM	=

VAL 	=	valgrind

all:	$(NAME) clean

$(NAME):	$(OBJ)
	$(COMP)

debug:	CFLAGS += -g3
debug:	$(NAMED) cleand
	clear
	$(VAL) ./$(NAMED) $(PARAM)

$(NAMED):	$(OBJD)
	$(COMP)

run:	all
	clear
	./$(NAME) $(PARAM)

.PHONY:	 cleand clean fclean re

cleand:
	rm -f $(OBJD)

clean:
	rm -f $(OBJ)

fclean: clean
	rm -f $(NAME)

re:	fclean all
